unit MainCtrl;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, WPDefs, WpWinCtr, WPRich, ExtCtrls, ComCtrls, AsciPrnt, Printers;

type
  TMainForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    Panel1: TPanel;
    TabSheet3: TTabSheet;
    Edit1: TEdit;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit8: TEdit;
    Button3: TButton;
    Button4: TButton;
    AsciiPrinter1: TAsciiPrinter;
    ListBox3: TListBox;
    Button5: TButton;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    Button6: TButton;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Memo2: TMemo;
    procedure PageControl1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListBox1Exit(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.PageControl1Change(Sender: TObject);
begin
if PageControl1.ActivePage.PageIndex= 3 then
 begin
  if not Button5.Enabled then
  with AsciiPrinter1 do
  {Set Page to reflect current properties}
   begin
    case Port of
     poLPT1: ListBox1.ItemIndex:=0;
     poLPT2: ListBox1.ItemIndex:=1;
     poCOM1: ListBox1.ItemIndex:=2;
     poCOM2: ListBox1.ItemIndex:=3;
     poCOM3: ListBox1.ItemIndex:=4;
     poCOM4: ListBox1.ItemIndex:=5;
     poCurrent: ListBox1.ItemIndex:=6;
     poDisk: ListBox1.ItemIndex:=7;
    end;

    case PrinterType of
     ptHPPCL: ListBox2.ItemIndex:=0;
     ptEpson: ListBox2.ItemIndex:=1;
     ptIBM: ListBox2.ItemIndex:=2;
     ptDiablo: ListBox2.ItemIndex:=3;
     ptPlain: ListBox2.ItemIndex:=4;
     ptUser1: ListBox2.ItemIndex:=5;
     ptUser2: ListBox2.ItemIndex:=6;
    end;
    Checkbox1.Checked := UseSpooler;
    Checkbox2.Checked := SendLineFeed;
    Checkbox3.Checked := PrintAllPages;
    Edit4.Text:=IntToStr(LeftOffset);
    Edit5.Text:=IntToStr(LinesPerPage);
    Edit6.Text:=IntToStr(LineWidth);
    case Pitch of
     cpi10: ListBox3.ItemIndex:=0;
     cpi12: ListBox3.ItemIndex:=1;
     cpi15: ListBox3.ItemIndex:=2;
    end;
    Edit2.Text:=IntToStr(PrintRangeStart);
    Edit3.Text:=IntToStr(PrintRangeEnd);
    Edit8.Text:=OutputFile;
    Button5.Enabled:=False;
   end;
 end;
{Enable/Disable some global buttons}
if PageControl1.ActivePage.PageIndex > 2 then
 begin
   Button1.Enabled:=False;
   Button2.Enabled:=False;
 end
else
 begin
   Button1.Enabled:=True;
   {Don't allow Normal print on page 2 - single line print}
   if PageControl1.ActivePage.PageIndex <> 2 then
     Button2.Enabled:=True
   else
     Button2.Enabled:=False;
 end;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
AsciiPrinter1.EditPrinterCodes;
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
AsciiPrinter1.EditTranslationTable;
end;

procedure TMainForm.ListBox1Exit(Sender: TObject);
begin
Button5.Enabled:=True;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
 {Write current setting to AsciiPrinter}
 with AsciiPrinter1 do
   begin
    case ListBox1.ItemIndex of
     0: Port:=poLPT1;
     1: Port:=poLPT2;
     2: Port:=poCOM1;
     3: Port:=poCOM2;
     4: Port:=poCOM3;
     5: Port:=poCOM4;
     6: Port:=poCurrent;
     7: Port:=poDisk;
    end;
    case ListBox2.ItemIndex of
     0: PrinterType:=ptHPPCL;
     1: PrinterType:=ptEpson;
     2: PrinterType:=ptIBM;
     3: PrinterType:=ptDiablo;
     4: PrinterType:=ptPlain;
     5: PrinterType:=ptUser1;
     6: PrinterType:=ptUser2;
    end;
    UseSpooler:= Checkbox1.Checked;
    SendLineFeed:=Checkbox2.Checked;
    PrintAllPages:=Checkbox3.Checked;
    Try
     if Edit4.Text <> '' then
      LeftOffset:=StrtoInt(Edit4.Text);
    except
     MessageDlg('Left Offset, must be a whole number', MtError, [mbOK], 0);
    end;

    Try
     if Edit5.Text <> '' then
      LinesperPage:=StrtoInt(Edit5.Text);
    except
     MessageDlg('Lines Per Page, must be a whole number', MtError, [mbOK], 0);
    end;

    Try
     if Edit6.Text <> '' then
      LineWidth:=StrtoInt(Edit6.Text);
    except
     MessageDlg('Characters Per Line, must be a whole number', MtError, [mbOK], 0);
    end;

    Case ListBox3.ItemIndex of
    0:  Pitch:=cpi10;
    1:  Pitch:=cpi12;
    2:  Pitch:=cpi15;
    end;

    Try
     if Edit2.Text <> '' then
      PrintRangeStart:=StrtoInt(Edit2.Text);
    except
     MessageDlg('Page Start, must be a whole number', MtError, [mbOK], 0);
    end;

    Try
     if Edit3.Text <> '' then
      PrintRangeEnd:=StrtoInt(Edit3.Text);
    except
     MessageDlg('Page End, must be a whole number', MtError, [mbOK], 0);
    end;
    OutputFile:=Edit8.Text;
    Button5.Enabled:=False;
 end;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
if PageControl1.ActivePage.PageIndex= 0 then
{Print TMemo}
 try
   AsciiPrinter1.PrintMemo(Memo1);
 except
       raise;
 end
else
 if PageControl1.ActivePage.PageIndex= 1 then
 {Print TMemo with Character Translation}
  try
   {Set Control codes}
   {~ - Bold on,  ^ - Bold Off
   !- Underline on, | - Underline Off  }

   {We could just load printer codes from file using AsciiPrinter.LoadTranslation table
   but we are going to do it manually for demonstration purposes.

   The characters used, are defined with the equivalent escape sequence to
   send to the printer. Of course there is nothing stopping you from using
   more sophisticated printer commands, such as font settings, character spacing, height
   and even bar codes, charts and graphics}

   AsciiPrinter1.TransIn.Clear;
   AsciiPrinter1.TransOut.Clear;

   case AsciiPrinter1.PrinterType of
   ptHPPCL:
           begin
             {Bold On}
             AsciiPrinter1.TransIn.Add('~');
             AsciiPrinter1.TransOut.Add(#27#40#115#51#66);
             {Bold Off}
             AsciiPrinter1.TransIn.Add('^');
             AsciiPrinter1.TransOut.Add(#27#40#115#48#66);
             {Underline On}
             AsciiPrinter1.TransIn.Add('!');
             AsciiPrinter1.TransOut.Add(#27#38#100#49#68);
             {Underline Off}
             AsciiPrinter1.TransIn.Add('|');
             AsciiPrinter1.TransOut.Add(#27#38#100#64);
           end;
   ptEpson:
           begin
             {Bold On}
             AsciiPrinter1.TransIn.Add('~');
             AsciiPrinter1.TransOut.Add(#27#71);
             {Bold Off}
             AsciiPrinter1.TransIn.Add('^');
             AsciiPrinter1.TransOut.Add(#27#72);
             {Underline On}
             AsciiPrinter1.TransIn.Add('!');
             AsciiPrinter1.TransOut.Add(#27#45#49);
             {Underline Off}
             AsciiPrinter1.TransIn.Add('|');
             AsciiPrinter1.TransOut.Add(#27#45#48);
           end;
   ptIBM:
           begin
             {Bold On}
             AsciiPrinter1.TransIn.Add('~');
             AsciiPrinter1.TransOut.Add(#27#69);
             {Bold Off}
             AsciiPrinter1.TransIn.Add('^');
             AsciiPrinter1.TransOut.Add(#27#70);
             {Underline On}
             AsciiPrinter1.TransIn.Add('!');
             AsciiPrinter1.TransOut.Add(#27#45#49);
             {Underline Off}
             AsciiPrinter1.TransIn.Add('|');
             AsciiPrinter1.TransOut.Add(#27#45#48);
           end;
   else
           begin
             {Bold On}
             AsciiPrinter1.TransIn.Add('~');
             AsciiPrinter1.TransOut.Add('');
             {Bold Off}
             AsciiPrinter1.TransIn.Add('^');
             AsciiPrinter1.TransOut.Add('');
             {Underline On}
             AsciiPrinter1.TransIn.Add('!');
             AsciiPrinter1.TransOut.Add('');
             {Underline Off}
             AsciiPrinter1.TransIn.Add('|');
             AsciiPrinter1.TransOut.Add('');
        end;
   end;

   AsciiPrinter1.PrintMemo(Memo2);

  except
   raise;
  end
 else
  if PageControl1.ActivePage.PageIndex= 2 then
  {Print Edit1.Text}
   try
    AsciiPrinter1.PrintString(Edit1.Text);
   except
    raise;
   end
  else
   MessageDlg('Please select a page to print', mtError, [mbOK], 0);
end;

procedure TMainForm.Button2Click(Sender: TObject);
var
  Line: Integer;
  PrintText: System.Text;

begin

if PageControl1.ActivePage.PageIndex= 0 then
{Print TMemo}
 begin
  if PrintDialog1.Execute then
   begin
    AssignPrn(PrintText);
    Rewrite(PrintText);
    Printer.Canvas.Font := Memo1.Font;
    for Line := 0 to Memo1.Lines.Count - 1 do
      Writeln(PrintText, Memo1.Lines[Line]);
    System.Close(PrintText);
   end;
 end
else
 if PageControl1.ActivePage.PageIndex= 1 then
 {Print TWPRichText}
  try
   if PrintDialog1.Execute then
    begin
    AssignPrn(PrintText);
    Rewrite(PrintText);
    Printer.Canvas.Font := Memo2.Font;
    for Line := 0 to Memo2.Lines.Count - 1 do
      Writeln(PrintText, Memo2.Lines[Line]);
    System.Close(PrintText);
    end;
  except
   raise;
  end
 else
  if PageControl1.ActivePage.PageIndex= 2 then
  {Print Edit1.Text}
   try
    AsciiPrinter1.PrintString(Edit1.Text);
   except
    raise;
   end
  else
   MessageDlg('Please select a page to print', mtError, [mbOK], 0);

end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
PrinterSetupDialog1.Execute;
end;

end.
